Scala Standard Library2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
    - `scala.collection.parallel.immutable` - Immutable, parallel data-structures such as `ParVector`, `ParRange`, `ParHashMap` or `ParHashSet`
    - `scala.collection.parallel.mutable` - Mutable, parallel data-structures such as `ParArray`, `ParHashMap`, `ParTrieMap` or `ParHashSet`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package collection

  Contains the base traits and objects needed to use and extend Scala's collection library.

  Contains the base traits and objects needed to use and extend Scala's collection library.

  #### Guide

  A detailed guide for using the collections library is available at http://docs.scala-lang.org/overviews/collections/introduction.html. Developers looking to extend the collections library can find a description of its architecture at http://docs.scala-lang.org/overviews/core/architecture-of-scala-collections.html.

  #### Using Collections

  It is convenient to treat all collections as either a scala.collection.Traversable or scala.collection.Iterable, as these traits define the vast majority of operations on a collection.

  Collections can, of course, be treated as specifically as needed, and the library is designed to ensure that the methods that transform collections will return a collection of the same type:

      scala> val array = Array(1,2,3,4,5,6)
      array: Array[Int] = Array(1, 2, 3, 4, 5, 6)

      scala> array map { _.toString }
      res0: Array[String] = Array(1, 2, 3, 4, 5, 6)

      scala> val list = List(1,2,3,4,5,6)
      list: List[Int] = List(1, 2, 3, 4, 5, 6)

      scala> list map { _.toString }
      res1: List[String] = List(1, 2, 3, 4, 5, 6)

  #### Creating Collections

  The most common way to create a collection is to use its companion object as a factory. The three most commonly used collections are scala.collection.Seq, scala.collection.immutable.Set, and scala.collection.immutable.Map. They can be used directly as shown below since their companion objects are all available as type aliases in either the scala package or in `scala.Predef`. New collections are created like this:

      scala> val seq = Seq(1,2,3,4,1)
      seq: Seq[Int] = List(1, 2, 3, 4, 1)

      scala> val set = Set(1,2,3,4,1)
      set: scala.collection.immutable.Set[Int] = Set(1, 2, 3, 4)

      scala> val map = Map(1 -> "one", 2 -> "two", 3 -> "three", 2 -> "too")
      map: scala.collection.immutable.Map[Int,String] = Map(1 -> one, 2 -> too, 3 -> three)

  It is also typical to prefer the scala.collection.immutable collections over those in scala.collection.mutable; the types aliased in the `scala.Predef` object are the immutable versions.

  Also note that the collections library was carefully designed to include several implementations of each of the three basic collection types. These implementations have specific performance characteristics which are described in the guide.

  The concrete parallel collections also have specific performance characteristics which are described in the parallel collections guide

  ##### Converting to and from Java Collections

  The scala.collection.JavaConverters object provides a collection of decorators that allow converting between Scala and Java collections using `asScala` and `asJava` methods.

  Definition Classes
    scala
-  package mutable
  Definition Classes
    collection
- AbstractBuffer
- AbstractIterable
- AbstractMap
- AbstractSeq
- AbstractSet
- AbstractSortedMap
- AbstractSortedSet
- AnyRefMap
- ArrayBuffer
- ArrayBuilder
- ArrayLike
- ArrayOps
- ArraySeq
- ArrayStack
- BitSet
- Buffer
- BufferLike
- BufferProxy
- Builder
- Cloneable
- DefaultEntry
- DefaultMapModel
- DoubleLinkedList
- DoubleLinkedListLike
- FlatHashTable
- GrowingBuilder
- HashEntry
- HashMap
- HashSet
- HashTable
- History
- ImmutableMapAdaptor
- ImmutableSetAdaptor
- IndexedSeq
- IndexedSeqLike
- IndexedSeqOptimized
- IndexedSeqView
- Iterable
- LazyBuilder
- LinearSeq
- LinkedEntry
- LinkedHashMap
- LinkedHashSet
- LinkedList
- LinkedListLike
- ListBuffer
- ListMap
- LongMap
- Map
- MapBuilder
- MapLike
- MapProxy
- MultiMap
- MutableList
- ObservableBuffer
- ObservableMap
- ObservableSet
- OpenHashMap
- PriorityQueue
- PriorityQueueProxy
- Publisher
- Queue
- QueueProxy
- ResizableArray
- ReusableBuilder
- RevertibleHistory
- Seq
- SeqLike
- Set
- SetBuilder
- SetLike
- SetProxy
- SortedMap
- SortedSet
- Stack
- StackProxy
- StringBuilder
- Subscriber
- SynchronizedBuffer
- SynchronizedMap
- SynchronizedPriorityQueue
- SynchronizedQueue
- SynchronizedSet
- SynchronizedStack
- Traversable
- TreeMap
- TreeSet
- Undoable
- UnrolledBuffer
- WeakHashMap
- WrappedArray
- WrappedArrayBuilder

t

scala.collection.mutable

# HashTable 

###

#### trait HashTable[A, Entry >: Null <: HashEntry[A, Entry]] extends HashUtils[A]

This class can be used to construct data structures that are based on hashtables. Class `HashTable[A]` implements a hashtable that maps keys of type `A` to values of the fully abstract member type `Entry`. Classes that make use of `HashTable` have to provide an implementation for `Entry`.

There are mainly two parameters that affect the performance of a hashtable: the initial size and the load factor. The size refers to the number of buckets in the hashtable, and the load factor is a measure of how full the hashtable is allowed to get before its size is automatically doubled. Both parameters may be changed by overriding the corresponding values in class `HashTable`.

A

  type of the elements contained in this hash table.

Source
  HashTable.scala
Version

  2.0, 31/12/2006

Since

  1

Linear Supertypes
HashUtils[A], AnyRef, Any
Known Subclasses
HashMap, LinkedHashMap, LinkedHashSet, ParHashMap, ParHashTable
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. HashTable
2. HashUtils
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1.  abstract def createNewEntry[B](key: A, value: B): Entry

   Creates new entry to be immediately inserted into the hashtable.

   Creates new entry to be immediately inserted into the hashtable. This method is guaranteed to be called only once and in case that the entry will be added. In other words, an implementation may be side-effecting.

   Attributes
     protected

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from HashTable[A, Entry] to any2stringadd[HashTable[A, Entry]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (HashTable[A, Entry], B)
   Implicit
     This member is added by an implicit conversion from HashTable[A, Entry] to ArrowAssoc[HashTable[A, Entry]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
6.  val _loadFactor: Int
   Attributes
     protected
   Annotations
     @transient()
7.  def addEntry(e: Entry): Unit

   Add entry to table pre: no entry with same key exists

   Add entry to table pre: no entry with same key exists

   Attributes
     protected
   Annotations
     @deprecatedOverriding( message = ... , since = "2.11.0" )
8.  def alwaysInitSizeMap: Boolean
   Attributes
     protected
9.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

10.  def calcSizeMapSize(tableLength: Int): Int
    Attributes
      protected
    Annotations
      @deprecatedOverriding( message = ... , since = "2.11.0" )
11.  def clearTable(): Unit

    Remove all entries from table

    Remove all entries from table

    Attributes
      protected
12.  def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13.  def elemEquals(key1: A, key2: A): Boolean
    Attributes
      protected
14.  def elemHashCode(key: A): Int
    Attributes
      protected
    Definition Classes
      HashUtils
15.  def ensuring(cond: (HashTable[A, Entry]) ⇒ Boolean, msg: ⇒ Any): HashTable[A, Entry]
    Implicit
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: (HashTable[A, Entry]) ⇒ Boolean): HashTable[A, Entry]
    Implicit
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean, msg: ⇒ Any): HashTable[A, Entry]
    Implicit
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  def ensuring(cond: Boolean): HashTable[A, Entry]
    Implicit
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
19.  def entriesIterator: Iterator[Entry]

    An iterator returning all entries.

    An iterator returning all entries.

    Attributes
      protected
20.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
21.  def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any
22.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

23.  def findEntry(key: A): Entry

    Find entry with given key in table, null if not found.

    Find entry with given key in table, null if not found.

    Attributes
      protected
    Annotations
      @deprecatedOverriding( message = ... , since = "2.11.0" )
24.  def findOrAddEntry[B](key: A, value: B): Entry

    Find entry with given key in table, or add new one if not found.

    Find entry with given key in table, or add new one if not found. May be somewhat faster then `findEntry`/`addEntry` pair as it computes entry's hash index only once. Returns entry found in table or null. New entries are created by calling `createNewEntry` method.

    Attributes
      protected
25.  def foreachEntry[U](f: (Entry) ⇒ U): Unit

    Avoid iterator for a 2x faster traversal.

    Avoid iterator for a 2x faster traversal.

    Attributes
      protected
26.  def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit
      This member is added by an implicit conversion from HashTable[A, Entry] to StringFormat[HashTable[A, Entry]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
27.  final def getClass(): Class[_]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
28.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
29.  final def improve(hcode: Int, seed: Int): Int

    Defer to a high-quality hash in scala.util.hashing.

    Defer to a high-quality hash in scala.util.hashing. The goal is to distribute across bins as well as possible even if a hash code has low entropy at some bits.

    OLD VERSION - quick, but bad for sequence 0-10000 - little entropy in higher bits - since 2003

        var h: Int = hcode + ~(hcode << 9)
        h = h ^ (h >>> 14)
        h = h + (h << 4)
        h ^ (h >>> 10)

    the rest of the computation is due to SI-5293

    Attributes
      protected
    Definition Classes
      HashUtils
30.  final def index(hcode: Int): Int

    Note: we take the most significant bits of the hashcode, not the lower ones this is of crucial importance when populating the table in parallel

    Note: we take the most significant bits of the hashcode, not the lower ones this is of crucial importance when populating the table in parallel

    Attributes
      protected
31.  def initWithContents(c: Contents[A, Entry]): Unit
    Attributes
      protected
32.  def initialSize: Int

    The initial size of the hash table.

    The initial size of the hash table.

    Attributes
      protected
33.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
34.  def isSizeMapDefined: Boolean
    Attributes
      protected
    Annotations
      @deprecatedOverriding( message = ... , since = "2.11.0" )
35.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
36.  def nnSizeMapAdd(h: Int): Unit
    Attributes
      protected
    Annotations
      @deprecatedOverriding( message = ... , since = "2.11.0" )
37.  def nnSizeMapRemove(h: Int): Unit
    Attributes
      protected
    Annotations
      @deprecatedOverriding( message = ... , since = "2.11.0" )
38.  def nnSizeMapReset(tableLength: Int): Unit
    Attributes
      protected
    Annotations
      @deprecatedOverriding( message = ... , since = "2.11.0" )
39.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

40.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

41.  def removeEntry(key: A): Entry

    Remove entry from table if present.

    Remove entry from table if present.

    Attributes
      protected
    Annotations
      @deprecatedOverriding( message = ... , since = "2.11.0" )
42.  val seedvalue: Int
    Attributes
      protected
    Annotations
      @transient()
43.  final def sizeMapBucketBitSize: Int
    Attributes
      protected
    Definition Classes
      HashUtils
44.  final def sizeMapBucketSize: Int
    Attributes
      protected
    Definition Classes
      HashUtils
45.  def sizeMapDisable(): Unit
    Attributes
      protected
    Annotations
      @deprecatedOverriding( message = ... , since = "2.11.0" )
46.  def sizeMapInit(tableLength: Int): Unit
    Attributes
      protected
47.  def sizeMapInitAndRebuild(): Unit
    Attributes
      protected
    Annotations
      @deprecatedOverriding( message = ... , since = "2.11.0" )
48.  val sizemap: Array[Int]

    The array keeping track of the number of elements in 32 element blocks.

    The array keeping track of the number of elements in 32 element blocks.

    Attributes
      protected
    Annotations
      @transient()
49.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
50.  val table: Array[HashEntry[A, Entry]]

    The actual hash table.

    The actual hash table.

    Attributes
      protected
    Annotations
      @transient()
51.  val tableSize: Int

    The number of mappings contained in this hash table.

    The number of mappings contained in this hash table.

    Attributes
      protected
    Annotations
      @transient()
52.  def tableSizeSeed: Int
    Attributes
      protected
53.  val threshold: Int

    The next size value at which to resize (capacity * load factor).

    The next size value at which to resize (capacity * load factor).

    Attributes
      protected
    Annotations
      @transient()
54.  def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any
55.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
56.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
57.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
58.  def →[B](y: B): (HashTable[A, Entry], B)
    Implicit
      This member is added by an implicit conversion from HashTable[A, Entry] to ArrowAssoc[HashTable[A, Entry]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from HashUtils[A]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from HashTable[A, Entry] to any2stringadd[HashTable[A, Entry]]

### Inherited by implicit conversion StringFormat from HashTable[A, Entry] to StringFormat[HashTable[A, Entry]]

### Inherited by implicit conversion Ensuring from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]]

### Inherited by implicit conversion ArrowAssoc from HashTable[A, Entry] to ArrowAssoc[HashTable[A, Entry]]

### Ungrouped